#ifndef DIAGONAL_H_INCLUDED
#define DIAGONAL_H_INCLUDED
int Diagonal(int Sudoku[9][9])
{
    //variable to which a value is assigned according to the case
    int temp;
    //loop that takes in the input and stores into the array Sudoku
    while(true)
    {
        Rectangle Normal(175,175,270,270);
        Rectangle*Tiles[9][9];
        Rectangle*Dividers[9][9];

        //Beginning of loop for creating tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Tiles[i][j]==NULL)
                {
                    return -1;
                }
                if((i>=0&&i<=2&&j>=0&&j<=2)||(i>=3&&i<=5&&j>=3&&j<=5)||(i>=6&&i<=8&&j>=6&&j<=8)||(i>=6&&i<=8&&j>=0&&j<=2)||(i>=0&&i<=2&&j>=6&&j<=8))
                {
                    Tiles[i][j]->setFill();
                    if((i!=j)&&((i+j)!=8))
                    {
                        Tiles[i][j]->setColor(COLOR(255,222,144));
                    }
                    if((i==j)||((i+j)==8))
                    {
                        Tiles[i][j]->setColor(COLOR(215,215,215));
                    }
                }
            }
        }
//End of loop for creating tiles
        Text Instruction2(300,20,"Give the Input For The Sudoku('0'for blank)");
//Beginning of loop for creating borders of tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Dividers[i][j]==NULL)
                {
                    return -1;
                }
                Dividers[i][j]->setColor(COLOR(255,77,26));
            }
        }
//End of loop for creating borders of tiles
//Creation of buttons for providing input
        Rectangle*Buttons[10];
        //loop for creation of buttons
        for(int i=0; i<=9; i++)
        {
            Buttons[i]=new Rectangle(100+40*i,380,30,30);
            if (Buttons[i]==NULL)
            {
                return -1;
            }
            Buttons[i]->setFill();
            Buttons[i]->setColor(COLOR(215,215,215));
        }
        Rectangle*ButtonDividers[10];
//Beginning of the loop for bordering of buttons
        for(int i=0; i<=9; i++)
        {
            ButtonDividers[i]=new Rectangle(100+40*i,380,30,30);
            if (ButtonDividers[i]==NULL)
            {
                return -1;
            }
            ButtonDividers[i]->setColor(COLOR(38,38,38));
        }

        Rectangle r(455,175,130,40);
        Text t(455,175,"Input");

//objects of type text for displaying numbers on the buttons
        Text p0(100+40*0,380,"0");
        Text p1(100+40*1,380,"1");
        Text p2(100+40*2,380,"2");
        Text p3(100+40*3,380,"3");
        Text p4(100+40*4,380,"4");
        Text p5(100+40*5,380,"5");
        Text p6(100+40*6,380,"6");
        Text p7(100+40*7,380,"7");
        Text p8(100+40*8,380,"8");
        Text p9(100+40*9,380,"9");

        int cx=0;
        int cy=0;

        int index=0;
//array for displaying the text at appropriate box
        Text *input[81];
//loop which takes in the input and assigns the value to the array and displays the number as a text on the canvas
        while(true)
        {
            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(cx==0&&cy==9)
            {
                break;
            }


            if(y>=365&&y<=395&&cy<=8)
            {
                if(x>=100-15&&x<=100+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"0");
                    Sudoku[cx][cy]=0;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=140-15&&x<=140+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"1");
                    Sudoku[cx][cy]=1;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }



                }
                if(x>=180-15&&x<=180+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"2");
                    Sudoku[cx][cy]=2;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }

                }
                if(x>=220-15&&x<=220+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"3");
                    Sudoku[cx][cy]=3;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=260-15&&x<=260+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"4");
                    Sudoku[cx][cy]=4;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=300-15&&x<=300+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"5");
                    Sudoku[cx][cy]=5;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }

                }
                if(x>=340-15&&x<=340+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"6");
                    Sudoku[cx][cy]=6;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=380-15&&x<=380+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"7");
                    Sudoku[cx][cy]=7;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=420-15&&x<=420+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"8");
                    Sudoku[cx][cy]=8;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=460-15&&x<=460+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"9");
                    Sudoku[cx][cy]=9;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
            }
        }
//loop for taking the input
        while(true)
        {
            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=455-65&&x<=455+65&&y<=175+20&&y>=175-20)
            {
                temp=7;
                break;
            }
        }
        //deletes all the objects that are displayed on the screen
        if(temp==7)
        {


            for(int i=0; i<9; i++)
            {
                for(int j=0; j<9; j++)
                {
                    if(Tiles[i][j]!=NULL&&Dividers[i][j]!=NULL)
                    {
                        delete Tiles[i][j];
                        delete Dividers[i][j];
                    }
                }
            }

            for(int i=0; i<10; i++)
            {
                if(Buttons[i]!=NULL&&ButtonDividers[i]!=NULL)
                {
                    delete Buttons[i];
                    delete ButtonDividers[i];
                }
            }
            for(int i=0; i<81; i++)
            {
                if(input[i]==NULL)
                {
                    return 0;
                }
                if(input[i]!=NULL)
                {
                    delete input[i];
                }
            }

            break;
        }
    }
//closes the program by giving an error message in case of invalid input
    if(!ValidD(Sudoku))
    {

        Text t1(300,225,"INVALID INPUT");
        Rectangle r2(300,300,50,30);
        Text t2(300,300,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=300+15&&y>=300-15)
            {
                return 0;
            }


        }
    }
    Rectangle rec1(300,100,130,40);
    Text t1(300,100,"SOLVE SUDOKU");
    Rectangle rec2(300,150,130,40);
    Text t2(300,150,"SHOW A TILE");
    Rectangle rec3(300,200,130,40);
    Text t3(300,200,"CHECK SOLUTION");
    Rectangle rec4(300,250,130,40);
    Text t4(300,250,"EXIT");
//loop for taking the input
    while(true)
    {
        int v=getClick();
        int x=v/65536;
        int y=v%65536;
        if(x>=300-65&&x<=300+65&&y<=100+20&&y>=100-20)
        {
            temp=23;
            break;
        }

        if(x>=300-65&&x<=300+65&&y<=150+20&&y>=150-20)
        {
            temp=24;
            break;
        }



        if(x>=300-65&&x<=300+65&&y<=200+20&&y>=200-20)
        {
            temp=25;
            break;
        }



        if(x>=300-65&&x<=300+65&&y<=250+20&&y>=250-20)
        {
            break;
            return 0;
        }

    }

    return temp;
}

int temp23(int Sudoku[9][9])
{
    int a = DSudoku(Sudoku);

    {
        if(a==1)
        {

            Text t1(300,5,"Solution is unique");

            Rectangle Normal(175,175,270,270);
            Rectangle*Tiles[9][9];
            Rectangle*Dividers[9][9];

            //Beginning of loop for creating tiles

            for(int i=0; i<=8; i++)
            {
                for(int j=0; j<=8; j++)
                {
                    Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                    if (Tiles[i][j]==NULL)
                    {
                        return -1;
                    }
                    if((i>=0&&i<=2&&j>=0&&j<=2)||(i>=3&&i<=5&&j>=3&&j<=5)||(i>=6&&i<=8&&j>=6&&j<=8)||(i>=6&&i<=8&&j>=0&&j<=2)||(i>=0&&i<=2&&j>=6&&j<=8))
                    {
                        Tiles[i][j]->setFill();
                        if((i!=j)&&((i+j)!=8))
                        {
                            Tiles[i][j]->setColor(COLOR(255,222,144));
                        }
                        if((i==j)||((i+j)==8))
                        {
                            Tiles[i][j]->setColor(COLOR(215,215,215));
                        }
                    }
                }
            }
            //End of loop for creating tiles
            //Beginning of loop for creating borders of tiles
            for(int i=0; i<=8; i++)
            {
                for(int j=0; j<=8; j++)
                {
                    Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                    if (Dividers[i][j]==NULL)
                    {
                        return -1;
                    }
                    Dividers[i][j]->setColor(COLOR(255,77,26));
                }
            }

            Text *input[81];
            int index=0;
            //loop that displays the whole grid
            for(int cx=0; cx<9; cx++)
            {
                for(int cy=0; cy<9; cy++)
                {
                    if(Sudoku[cx][cy]==0)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"0");
                        index++;
                    }

                    if(Sudoku[cx][cy]==1)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"1");
                        index++;
                    }

                    if(Sudoku[cx][cy]==2)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"2");
                        index++;
                    }

                    if(Sudoku[cx][cy]==3)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"3");
                        index++;
                    }

                    if(Sudoku[cx][cy]==4)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"4");
                        index++;
                    }

                    if(Sudoku[cx][cy]==5)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"5");
                        index++;
                    }

                    if(Sudoku[cx][cy]==6)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"6");
                        index++;
                    }

                    if(Sudoku[cx][cy]==7)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"7");
                        index++;
                    }

                    if(Sudoku[cx][cy]==8)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"8");
                        index++;
                    }

                    if(Sudoku[cx][cy]==9)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"9");
                        index++;
                    }
                }
            }

            Rectangle r(400,225,100,30);
            Text t(400,225,"EXIT");
//loop for taking the input
            while(true)
            {

                int v=getClick();
                int x=v/65536;
                int y=v%65536;
                if(x>=400-50&&x<=400+50&&y<=225+15&&y>=225-15)
                {
                    return 0;
                }


            }
        }

        if(a==0)
        {
            Text t1(300,5,"Solution is not unique");

            Rectangle Normal(175,175,270,270);
            Rectangle*Tiles[9][9];
            Rectangle*Dividers[9][9];
            //Beginning of loop for creating tiles
            for(int i=0; i<=8; i++)
            {
                for(int j=0; j<=8; j++)
                {
                    Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                    if (Tiles[i][j]==NULL)
                    {
                        return -1;
                    }
                    if((i>=0&&i<=2&&j>=0&&j<=2)||(i>=3&&i<=5&&j>=3&&j<=5)||(i>=6&&i<=8&&j>=6&&j<=8)||(i>=6&&i<=8&&j>=0&&j<=2)||(i>=0&&i<=2&&j>=6&&j<=8))
                    {
                        Tiles[i][j]->setFill();
                        if((i!=j)&&((i+j)!=8))
                        {
                            Tiles[i][j]->setColor(COLOR(255,222,144));
                        }
                        if((i==j)||((i+j)==8))
                        {
                            Tiles[i][j]->setColor(COLOR(215,215,215));
                        }
                    }
                }
            }
            //End of loop for creating tiles
            //Beginning of loop for creating borders of tiles
            for(int i=0; i<=8; i++)
            {
                for(int j=0; j<=8; j++)
                {
                    Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                    if (Dividers[i][j]==NULL)
                    {
                        return -1;
                    }
                    Dividers[i][j]->setColor(COLOR(255,77,26));
                }
            }
            //End of loop for creating borders of tiles
            //array for displaying the text at appropriate box
            Text *input[81];
            int index=0;
            //loop that displays the whole grid
            for(int cx=0; cx<9; cx++)
            {
                for(int cy=0; cy<9; cy++)
                {
                    if(Sudoku[cx][cy]==0)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"0");
                        index++;
                    }

                    if(Sudoku[cx][cy]==1)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"1");
                        index++;
                    }

                    if(Sudoku[cx][cy]==2)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"2");
                        index++;
                    }

                    if(Sudoku[cx][cy]==3)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"3");
                        index++;
                    }

                    if(Sudoku[cx][cy]==4)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"4");
                        index++;
                    }

                    if(Sudoku[cx][cy]==5)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"5");
                        index++;
                    }

                    if(Sudoku[cx][cy]==6)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"6");
                        index++;
                    }

                    if(Sudoku[cx][cy]==7)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"7");
                        index++;
                    }

                    if(Sudoku[cx][cy]==8)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"8");
                        index++;
                    }

                    if(Sudoku[cx][cy]==9)
                    {
                        input[index]=new Text(55+30*cx,55+30*cy,"9");
                        index++;
                    }
                }
            }

            Rectangle r(400,225,100,30);
            Text t(400,225,"EXIT");

            while(true)
            {
                int v=getClick();
                int x=v/65536;
                int y=v%65536;
                if(x>=400-50&&x<=400+50&&y<=225+15&&y>=225-15)
                {
                    return 0;
                }
            }
        }

        if(a==-1)
        {

            Text t1(300,225,"No Solution exists");
            Rectangle r(300,275,50,30);
            Text t2(300,275,"EXIT");
            //loop for taking the input
            while(true)
            {

                int v=getClick();
                int x=v/65536;
                int y=v%65536;
                if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
                {
                    return 0;
                }
            }
        }

    }

}

int temp24(int Sudoku[9][9])
{

    Text t(380,175,"select the tile");
    wait(0.5);
    Rectangle Normal(175,175,270,270);
    Rectangle*Tiles[9][9];
    Rectangle*Dividers[9][9];

    //Beginning of loop for creating tiles
    for(int i=0; i<=8; i++)
    {
        for(int j=0; j<=8; j++)
        {
            Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
            if (Tiles[i][j]==NULL)
            {
                return -1;
            }
            if((i>=0&&i<=2&&j>=0&&j<=2)||(i>=3&&i<=5&&j>=3&&j<=5)||(i>=6&&i<=8&&j>=6&&j<=8)||(i>=6&&i<=8&&j>=0&&j<=2)||(i>=0&&i<=2&&j>=6&&j<=8))
            {
                Tiles[i][j]->setFill();
                if((i!=j)&&((i+j)!=8))
                {
                    Tiles[i][j]->setColor(COLOR(255,222,144));
                }
                if((i==j)||((i+j)==8))
                {
                    Tiles[i][j]->setColor(COLOR(215,215,215));
                }
            }
        }
    }
//End of loop for creating tiles

//Beginning of loop for creating borders of tiles
    for(int i=0; i<=8; i++)
    {
        for(int j=0; j<=8; j++)
        {
            Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
            if (Dividers[i][j]==NULL)
            {
                return -1;
            }
            Dividers[i][j]->setColor(COLOR(255,77,26));
        }
    }
    //End of loop for creating borders of tiles
    //array for displaying the text at appropriate box
    Text *input[81];
    int index=0;

//loop that displays the whole grid
    for(int cx=0; cx<9; cx++)
    {

        for(int cy=0; cy<9; cy++)
        {
            if(Sudoku[cx][cy]==0)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"0");
                index++;
            }

            if(Sudoku[cx][cy]==1)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"1");
                index++;
            }

            if(Sudoku[cx][cy]==2)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"2");
                index++;
            }

            if(Sudoku[cx][cy]==3)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"3");
                index++;
            }

            if(Sudoku[cx][cy]==4)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"4");
                index++;
            }

            if(Sudoku[cx][cy]==5)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"5");
                index++;
            }

            if(Sudoku[cx][cy]==6)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"6");
                index++;
            }

            if(Sudoku[cx][cy]==7)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"7");
                index++;
            }

            if(Sudoku[cx][cy]==8)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"8");
                index++;
            }

            if(Sudoku[cx][cy]==9)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"9");
                index++;
            }

        }

    }
    int index1,index2;
    while(true)
    {

        int v=getClick();
        int x=v/65536;
        int y=v%65536;
        index1=(x-40)/30;
        index2=(y-40)/30;
        if(index1>=0&&index1<9&&index2>=0&&index2<9)
        {
            Rectangle r(55+30*index1,55+30*index2,30,30);
            r.setColor(COLOR(234,255,79));
            wait(1);
            for(int i=0; i<9; i++)
            {
                for(int j=0; j<9; j++)
                {
                    if(Tiles[i][j]!=NULL&&Dividers[i][j]!=NULL)
                    {
                        delete Tiles[i][j];
                        delete Dividers[i][j];
                    }
                }
            }

            for(int i=0; i<81; i++)
            {
                if(input[i]==NULL)
                {
                    return 0;
                }
                if(input[i]!=NULL)
                {
                    delete input[i];
                }
            }

            Normal.hide();
            t.hide();
        }
        break;
    }

    if (Sudoku[index1][index2]!=0)
    {
        Text t1(300,225,"Tile already displayed");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }
    }

    int B[9][9];
    CopyGrid(Sudoku,B);
    int a = DSudoku(B);
    switch(a)
    {
    case -1:
    {
        Text t1(300,225,"No Solution exists");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }
        }
    }
    break;

    case 0:
    {
        Rectangle temporary(300,225,600,450);
        Text t1(300,225,"Multiple Solutions Possible");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }
        }
    }
    break;

    case 1:
    {
        Rectangle temporary(300,225,600,450);
        Sudoku[index1][index2]=B[index1][index2];
        Rectangle Normal(175,175,270,270);
        Rectangle*Tiles[9][9];
        Rectangle*Dividers[9][9];

        //Beginning of loop for creating tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Tiles[i][j]==NULL)
                {
                    return -1;
                }
                if((i>=0&&i<=2&&j>=0&&j<=2)||(i>=3&&i<=5&&j>=3&&j<=5)||(i>=6&&i<=8&&j>=6&&j<=8)||(i>=6&&i<=8&&j>=0&&j<=2)||(i>=0&&i<=2&&j>=6&&j<=8))
                {
                    Tiles[i][j]->setFill();
                    if((i!=j)&&((i+j)!=8))
                    {
                        Tiles[i][j]->setColor(COLOR(255,222,144));
                    }
                    if((i==j)||((i+j)==8))
                    {
                        Tiles[i][j]->setColor(COLOR(215,215,215));
                    }
                }
            }
        }
        //End of loop for creating tiles
        //Beginning of loop for creating borders of tiles

        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Dividers[i][j]==NULL)
                {
                    return -1;
                }
                Dividers[i][j]->setColor(COLOR(255,77,26));
            }
        }
        //End of loop for creating borders of tiles
        //array for displaying the text at appropriate box
        Text *input[81];
        int index=0;
        //loop that displays the whole grid
        for(int cx=0; cx<9; cx++)
        {

            for(int cy=0; cy<9; cy++)
            {

                if(Sudoku[cx][cy]==0)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"0");
                    index++;
                }

                if(Sudoku[cx][cy]==1)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"1");
                    index++;
                }

                if(Sudoku[cx][cy]==2)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"2");
                    index++;
                }

                if(Sudoku[cx][cy]==3)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"3");
                    index++;
                }

                if(Sudoku[cx][cy]==4)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"4");
                    index++;
                }

                if(Sudoku[cx][cy]==5)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"5");
                    index++;
                }

                if(Sudoku[cx][cy]==6)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"6");
                    index++;
                }

                if(Sudoku[cx][cy]==7)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"7");
                    index++;
                }

                if(Sudoku[cx][cy]==8)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"8");
                    index++;
                }

                if(Sudoku[cx][cy]==9)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"9");
                    index++;
                }

            }

        }

        Rectangle r1(400,200,100,40);
        Text t1(400,200,"Solve Sudoku");
        Rectangle r2(400,275,50,30);
        Text t2(400,275,"Exit");
        while(true)
        {
            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=400-25&&x<=400+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }
            if(x>=400-50&&x<=400+50&&y<=200+20&&y>=200-20)
            {
                r1.hide();
                r2.hide();
                t1.hide();
                t2.hide();
                Rectangle temporary(300,225,600,450);
                temporary.setColor(COLOR(255,255,255));
                temporary.setFill();
                return temp20(Sudoku);
            }
        }

    }

    }
}
int temp25(int C[9][9])
{
    Rectangle temporary(300,225,600,450);
    temporary.setColor(COLOR(255,255,255));
    temporary.setFill();
    int Sudoku[9][9], temp;
    //loop that takes in the input and stores into the array Sudoku
    while(true)
    {
        int cx=0;
        int cy=0;
        Rectangle Normal(175,175,270,270);
        Rectangle*Tiles[9][9];
        Rectangle*Dividers[9][9];
        //Beginning of loop for creating tiles

        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Tiles[i][j]==NULL)
                {
                    return -1;
                }
                if((i>=0&&i<=2&&j>=0&&j<=2)||(i>=3&&i<=5&&j>=3&&j<=5)||(i>=6&&i<=8&&j>=6&&j<=8)||(i>=6&&i<=8&&j>=0&&j<=2)||(i>=0&&i<=2&&j>=6&&j<=8))
                {
                    Tiles[i][j]->setFill();
                    if((i!=j)&&((i+j)!=8))
                    {
                        Tiles[i][j]->setColor(COLOR(255,222,144));
                    }
                    if((i==j)||((i+j)==8))
                    {
                        Tiles[i][j]->setColor(COLOR(215,215,215));
                    }
                }
            }
        }
        //End of loop for creating tiles
        Text Instruction2(300,20,"Give the Input For The Solution");
        //Beginning of loop for creating borders of tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Dividers[i][j]==NULL)
                {
                    return -1;
                }
                Dividers[i][j]->setColor(COLOR(255,77,26));
            }
        }
        //End of loop for creating borders of tiles
        //Creation of buttons for providing input
        Rectangle*Buttons[10];
        for(int i=0; i<=9; i++)
        {
            Buttons[i]=new Rectangle(100+40*i,380,30,30);
            if (Buttons[i]==NULL)
            {
                return -1;
            }
            Buttons[i]->setFill();
            Buttons[i]->setColor(COLOR(215,215,215));
        }
        Rectangle*ButtonDividers[10];
        //Beginning of the loop for bordering of buttons
        for(int i=0; i<=9; i++)
        {
            ButtonDividers[i]=new Rectangle(100+40*i,380,30,30);
            if (ButtonDividers[i]==NULL)
            {
                return -1;
            }
            ButtonDividers[i]->setColor(COLOR(38,38,38));
        }


        Rectangle r(455,175,130,40);
        Text t(455,175,"Input");

        //objects of type text for displaying numbers on the buttons
        Text p0(100+40*0,380,"0");
        Text p1(100+40*1,380,"1");
        Text p2(100+40*2,380,"2");
        Text p3(100+40*3,380,"3");
        Text p4(100+40*4,380,"4");
        Text p5(100+40*5,380,"5");
        Text p6(100+40*6,380,"6");
        Text p7(100+40*7,380,"7");
        Text p8(100+40*8,380,"8");
        Text p9(100+40*9,380,"9");


        int index=0;
        //array for displaying the text at appropriate box
        Text *input[81];
        //loop which takes in the input and assigns the value to the array and displays the number as a text on the canvas
        for(int i=0; i>=0; i++)
        {
            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(cx==0&&cy==9)
            {
                break;
            }

            if(y>=365&&y<=395&&cy<=8)
            {
                if(x>=100-15&&x<=100+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"0");
                    Sudoku[cx][cy]=0;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                    {
                        index++;
                    }

                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=140-15&&x<=140+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"1");
                    Sudoku[cx][cy]=1;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                    {
                        index++;
                    }

                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }

                if(x>=180-15&&x<=180+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"2");
                    Sudoku[cx][cy]=2;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }

                }
                if(x>=220-15&&x<=220+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"3");
                    Sudoku[cx][cy]=3;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=260-15&&x<=260+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"4");
                    Sudoku[cx][cy]=4;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=300-15&&x<=300+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"5");
                    Sudoku[cx][cy]=5;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }

                }
                if(x>=340-15&&x<=340+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"6");
                    Sudoku[cx][cy]=6;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=380-15&&x<=380+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"7");
                    Sudoku[cx][cy]=7;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=420-15&&x<=420+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"8");
                    Sudoku[cx][cy]=8;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
                if(x>=460-15&&x<=460+15)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"9");
                    Sudoku[cx][cy]=9;
                    if(input[index]==NULL)
                    {
                        cout<<"memory allocation failure";
                        return -1;
                    }
                    else
                        index++;
                    if(cx<=8)
                    {
                        cx++;
                    }
                    if(cx==9)
                    {
                        cx=0;
                        cy++;
                    }
                }
            }

        }
        while(true)
        {
            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=455-65&&x<=455+65&&y<=175+20&&y>=175-20)
            {
                temp=6;
                break;
            }
        }
        //deletes all the objects that are displayed on the screen
        if(temp==6)
        {


            for(int i=0; i<9; i++)
            {
                for(int j=0; j<9; j++)
                {
                    if(Tiles[i][j]!=NULL&&Dividers[i][j]!=NULL)
                    {
                        delete Tiles[i][j];
                        delete Dividers[i][j];
                    }
                }
            }

            for(int i=0; i<10; i++)
            {
                if(Buttons[i]!=NULL&&ButtonDividers[i]!=NULL)
                {
                    delete Buttons[i];
                    delete ButtonDividers[i];
                }
            }
            for(int i=0; i<81; i++)
            {
                if(input[i]==NULL)
                {
                    return 0;
                }
                if(input[i]!=NULL)
                {
                    delete input[i];
                }
            }

            break;
        }
    }

    int b = CheckDSudoku(C,Sudoku);
    switch(b)
    {
    case 1:
    {
        Rectangle temporary(300,225,600,450);
        temporary.setColor(COLOR(255,255,255));
        temporary.setFill();
        Text t1(300,225,"Solution is Correct");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }
    }
    break;

    case 0:
    {
        Rectangle temporary(300,225,600,450);
        temporary.setColor(COLOR(255,255,255));
        temporary.setFill();
        Text t1(300,225,"Solution is Incorrect");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }

    }
    break;

    case -1:
    {
        Rectangle temporary(300,225,600,450);
        temporary.setColor(COLOR(255,255,255));
        temporary.setFill();
        Text t1(300,225,"Solution is Incomplete");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }

    }
    }
}




#endif // DIAGONAL_H_INCLUDED
