#include<simplecpp>
#include"sudoku.h"
#include "normal.h"
#include "diagonal.h"
#include "window.h"
#include"jigsaw.h"
using namespace std;

int main()
{

    int Sudoku[9][9];
    int temp;
    initCanvas("sudoku autosolver",600,450);

    for(int i=0; i>=0; i++)
    {
        Text t1(300,100,"SUDOKU AUTO-SOLVER");

        Rectangle a(300,170,120,50);
        Text t2(300,170,"START GAME");

        Rectangle s(300,240,120,50);
        Text t3(300,240,"EXIT");

        int v=getClick();
        int x=v/65536;
        int y=v%65536;
        if(x>=300-60&&x<=300+60&&y<=170+25&&y>=170-25)
        {
            temp=1;
            break;
        }
        if(x>=300-60&&x<=300+60&&y<=240+25&&y>=240-25)
        {
            temp=0;
            break;
        }

    }

    if(temp==0)
    {
        return 0;
    }

    if(temp==1)
    {
        while(true)
        {
            Text t1(300,84.375,"SELECT THE TYPE OF SUDOKU");
            Rectangle rec2(300,191.25,140,40);
            Text t2(300,191.25,"NORMAL SUDOKU");
            Rectangle rec3(300,247.5,140,40);
            Text t3(300,247.5,"DIAGONAL SUDOKU");
            Rectangle rec4(300,303.75,140,40);
            Text t4(300,303.75,"WINDOW SUDOKU");
            Rectangle rec5(300,360,140,40);
            Text t5(300,360,"JIGSAW SUDOKU");
            Rectangle rec6(300,416.25,140,40);
            Text t6(300,416.25,"EXIT");

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-70&&x<=300+70&&y<=191.25+20&&y>=191.25-20)
            {
                temp=1;
                break;
            }

            if(x>=300-70&&x<=300+70&&y<=247.5+20&&y>=247.5-20)
            {
                temp=2;
                break;
            }
            if(x>=300-70&&x<=300+70&&y<=303.75+20&&y>=303.75-20)
            {
                temp=3;
                break;
            }
            if(x>=300-70&&x<=300+70&&y<=360+20&&y>=360-20)
            {
                temp=4;
                break;
            }
            if(x>=300-70&&x<=300+70&&y<=416.25+20&&y>=416.25-20)
            {
                temp=0;
                break;
            }

        }
    }

    if(temp==0)
    {
        return 0;
    }

    if(temp==1)
    {
        temp = Normal(Sudoku);

        if(temp==20)
        {
            return temp20(Sudoku);
        }

        if(temp==21)
        {
            return temp21(Sudoku);
        }


        if(temp==22)
        {
            return temp22(Sudoku);
        }

    }


    if(temp==2)
    {
        temp = Diagonal(Sudoku);
        if(temp==23)
        {
            return temp23(Sudoku);
        }


        if(temp==24)
        {
            return temp24(Sudoku);
        }
        if(temp==25)
        {
            return temp25(Sudoku);
        }

    }




    if(temp==3)
    {
        temp = Window(Sudoku);
        if(temp==26)
        {
            return temp26(Sudoku);
        }

        if(temp==27)
        {
            return temp27(Sudoku);
        }

        if(temp==28)
        {
            return temp28(Sudoku);
        }
    }


    if(temp==4)
    {
        jig sudoku;
        temp = Jigsaw(sudoku);
        if(temp==29)
        {
            return temp29(sudoku);
        }

        if(temp==30)
        {
            return temp30(sudoku);
        }

        if(temp==31)
        {
            return temp31(sudoku);
        }
    }


    return 0;

}

